% LaTeX Dokumentenklasse fr das FKFS-Autotest 
% abgeleitet von der LNI Reihe der GI
%
%
%
\ProvidesClass{fkfs}[2008/04/30 v0.01, by Michael Brost]

\newif\ifpdf\ifx\pdfoutput\undefined\pdffalse\else\pdfoutput=1\pdftrue\fi


\DeclareOption{forInclusion}{%
  \setlength{\topmargin}{0mm}%
  \setlength{\headheight}{0mm}%
  \setlength{\headsep}{0mm}%
  \setlength{\hoffset}{0mm}% 
  \setlength{\voffset}{0mm}% 
  \setlength{\oddsidemargin}{5mm}%
  \setlength{\evensidemargin}{5mm}%
  \setlength{\paperheight}{297mm}%
  \setlength{\paperwidth}{210mm}
  \ifpdf%
    \setlength{\pdfpageheight}{297mm}%
    \setlength{\pdfpagewidth}{210mm}%
  \fi
  }

\newif\iflnienglish\lnienglishfalse
\DeclareOption{english}{\lnienglishtrue}

\ProcessOptions

\LoadClass[12pt,a4paper]{article}
\RequirePackage[english,ngerman]{babel}
\iflnienglish\selectlanguage{english}\def\bbl@main@language{english}\fi
% Blocksatz durch LaTeX-Default
%\addtolength{\topmargin}{8mm}
%\addtolength{\oddsidemargin}{-2.5mm}
%\setlength{\evensidemargin}{\oddsidemargin}
	
  \setlength{\topmargin}{0mm}%
  \setlength{\headheight}{0mm}%
  \setlength{\headsep}{0mm}%
  \setlength{\hoffset}{0mm}% 
  \setlength{\voffset}{0mm}% 
  \setlength{\oddsidemargin}{5mm}%
  \setlength{\evensidemargin}{5mm}%
  \setlength{\paperheight}{297mm}%
  \setlength{\paperwidth}{210mm}	
	\setlength{\textheight}{240mm}
	\setlength{\textwidth}{150mm}
	
% Times als Grundschrift
\RequirePackage{times}
% Hyphenation
% Durch normale LaTeX-Parameter verhindert (\doublehyphendemerits)

% Title: Kopie aus article.cls mit anderem \thispagestyle
\renewcommand\maketitle{\par
  \begingroup
    \renewcommand\thefootnote{\@fnsymbol\c@footnote}%
    \def\@makefnmark{\rlap{\@textsuperscript{\normalfont\@thefnmark}}}%
    \long\def\@makefntext##1{\parindent 0.2em\noindent
            \hb@xt@0.2em{%
                \hss\@textsuperscript{\normalfont\@thefnmark}}##1}%
    \if@twocolumn
      \ifnum \col@number=\@ne
        \@maketitle
      \else
        \twocolumn[\@maketitle]%
      \fi
    \else
      \newpage
      \global\@topnum\z@   % Prevents figures from going at top of page.
      \@maketitle
    \fi
    \thispagestyle{empty}\@thanks
  \endgroup
  \setcounter{footnote}{0}%
  \global\let\thanks\relax
  \global\let\maketitle\relax
  \global\let\@maketitle\relax
  \global\let\@thanks\@empty
  \global\let\@author\@empty
  \global\let\@date\@empty
  \global\let\@title\@empty
  \global\let\title\relax
  \global\let\author\relax
  \global\let\date\relax
  \global\let\and\relax
}
\def\@maketitle{%
  \newpage
  \null
  \vskip 2em%
  \begin{center}%
  \let \footnote \thanks
    {\fontsize{14}{15}\fontseries{b}\selectfont \@title \par}%
    \vskip 1.5em%
    {\fontsize{12}{12}\selectfont
      \lineskip .5em%
      \begin{tabular}[t]{c}%
        \@author
      \end{tabular}\par}%
    \vskip 1\baselineskip%
  \end{center}%
  \par
  }

% Abstract
\renewenvironment*{abstract}{%
 \renewcommand{\abstractname}{Abstract}
 \fontsize{12}{14}\selectfont
    \quotation\noindent{\bfseries \abstractname:}%
}{\endquotation}  

% berschriften
\renewcommand{\section}{\@startsection{section}{1}{\z@}%
  {2\baselineskip}{\baselineskip}{\fontsize{12}{14}\fontseries{b}\selectfont}}
\renewcommand{\subsection}{\@startsection{subsection}{2}{\z@}%
  {2\baselineskip}{\baselineskip}{\fontsize{12}{13}\fontseries{b}\selectfont}}
% weitere nicht durch Formatvorlage geklrt

% keine seitennummern
\pagestyle{empty}

% Bildunterschriften
\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  {\fontsize{12}{12}\selectfont
   \sbox\@tempboxa{#1: #2}%
  \ifdim \wd\@tempboxa >\hsize
    #1: #2\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi}
  \vskip\belowcaptionskip}

% gleichungen mit richtiger einrckung
% fleqn-Option oben
% \setlength{\mathindent}{4ex}

% listings mit richtiger einrckung
\RequirePackage{verbatim}
\def\verbatim@processline{\hskip4ex\the\verbatim@line\par}

% Fussnoten mit 5cm Linie und richtiger Gre
\renewcommand\footnoterule{%
  \kern-3\p@
  \hrule\@width5cm
  \kern2.6\p@}
\renewcommand\@makefntext[1]{%
    \parindent 1em%
    \noindent
    \hb@xt@1.8em{\hss\@makefnmark}{\fontsize{10}{12}\selectfont#1}}

% Gemutmate Absatzeinzge und Abstnde
\parindent0pt
\parskip 1ex

% bibliography
\iflanguage{english}{\bibliographystyle{fkfs}}{\bibliographystyle{fkfsg}}
\renewenvironment{thebibliography}[1]
     {%\def\refname{Literaturverzeichnis}
      \section*{\refname}%
      \bgroup\fontsize{12}{14}\selectfont
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist\egroup}
